var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
import React from 'react';
import styled from 'styled-components';
import { useTheme } from "../../../theme";
import { Button } from "../../inputs";
import { Loader } from "../../modules";
import { TableCell } from '../Table';
import { Icon } from '../Icon';
import { Container } from '../Container';
export var Cell = styled(TableCell).withConfig({ displayName: "Cell", componentId: "sc-1nuo5tb" })(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  background-color: ", ";\n"], ["\n  background-color: ", ";\n"])), function (_a) {
    var cellColor = _a.cellColor;
    return cellColor;
});
var ActionCellButtons = styled.div.withConfig({ displayName: "ActionCellButtons", componentId: "sc-1kivk3a" })(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n  display: flex;\n  align-items: center;\n  justify-content: center;\n\n  & > button {\n    margin-right: 10px;\n  }\n"], ["\n  display: flex;\n  align-items: center;\n  justify-content: center;\n\n  & > button {\n    margin-right: 10px;\n  }\n"])));
export var ActionCellContainer = styled(Container).withConfig({ displayName: "ActionCellContainer", componentId: "sc-ructls" })(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n  display: flex;\n  justify-content: center;\n  align-items: center;\n"], ["\n  display: flex;\n  justify-content: center;\n  align-items: center;\n"])));
export var ActionCell = function (_a) {
    var children = _a.children, onCancel = _a.onCancel, onAccept = _a.onAccept, _b = _a.className, className = _b === void 0 ? '' : _b, disable = _a.disable, isLoading = _a.isLoading, _c = _a.color, color = _c === void 0 ? 'primary' : _c, error = _a.error, _d = _a.colSpan, colSpan = _d === void 0 ? 5 : _d;
    var colors = useTheme().colors;
    var cellColor = colors[color].default;
    return (React.createElement(Cell, { colSpan: colSpan, className: 'ActionCell ' + className, cellColor: cellColor },
        React.createElement(ActionCellContainer, null,
            children,
            React.createElement(ActionCellButtons, null, isLoading ? (React.createElement(Loader, { active: true, inline: true })) : (React.createElement(React.Fragment, null,
                React.createElement(Button, { inverted: true, circular: true, color: color, onClick: onCancel },
                    React.createElement(Icon, { name: "times", fitted: true })),
                React.createElement(Button, { inverted: true, circular: true, color: color, onClick: onAccept, disabled: disable || false },
                    React.createElement(Icon, { name: "check", fitted: true })),
                Boolean(error) && error))))));
};
var templateObject_1, templateObject_2, templateObject_3;
