var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React, { useEffect, useRef } from 'react';
import AceEditor from 'react-ace';
import { equals } from 'ramda';
import 'ace-builds/src-min-noconflict/mode-elixir';
import 'ace-builds/src-min-noconflict/theme-chrome';
import 'ace-builds/src-min-noconflict/ext-language_tools';
import CustomElixirMode from './CustomElixirMode';
import { getRules, initAceEditor } from './utils';
export var CodeEditor = function (_a) {
    var _b = _a.variables, variables = _b === void 0 ? {} : _b, onLoad = _a.onLoad, readOnly = _a.readOnly, completers = _a.completers, rest = __rest(_a, ["variables", "onLoad", "readOnly", "completers"]);
    var aceEditorRef = useRef(null);
    var prevVariablesRef = useRef(null);
    useEffect(function () {
        var _a;
        // deeply compare variables props with previous props and set new custom mode only if variables object has changed
        if (!equals(variables, prevVariablesRef.current)) {
            prevVariablesRef.current = variables;
            var variablesRules = getRules(variables);
            var customMode = new CustomElixirMode(variablesRules);
            (_a = aceEditorRef.current) === null || _a === void 0 ? void 0 : _a.editor.getSession().setMode(customMode);
        }
    }, [variables]);
    var handleLoad = function (editor) {
        initAceEditor(editor, completers);
        if (onLoad) {
            onLoad(editor);
        }
    };
    var options = { highlightGutterLine: !readOnly };
    return (React.createElement(AceEditor, __assign({ ref: aceEditorRef, highlightActiveLine: !readOnly, onLoad: handleLoad, readOnly: readOnly, width: "100%", mode: "elixir", theme: "chrome", setOptions: options }, rest)));
};
