var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import ace from 'ace-builds';
import 'ace-builds/src-min-noconflict/mode-elixir';
import { insert } from './utils';
var CustomHighlightRules = /** @class */ (function (_super) {
    __extends(CustomHighlightRules, _super);
    function CustomHighlightRules(rules) {
        var _this = _super.call(this) || this;
        // find 'keyword.control.elixir' rule index
        var controlKeywordIndex = _this.$rules.start.findIndex(function (rule) { return rule.token === 'keyword.control.elixir'; });
        // add 'ki|when|on|' to start of regexp, result will be "\b(?:ki|when|on|do|end|case|bc|lc|for|if ...
        _this.$rules.start[controlKeywordIndex].regex = insert(_this.$rules.start[controlKeywordIndex].regex, 'ki|when|on|', 5);
        // remove elixir constants rule
        // in order to allow highlighting of variables starting with capital letter
        var constantVariableIndex = _this.$rules.start.findIndex(function (rule) { return rule.token === 'variable.other.constant.elixir'; });
        _this.$rules.start.splice(constantVariableIndex, 1);
        // add rules to highlight variables (plain, missing, todo)
        if (rules) {
            _this.$rules.start = _this.$rules.start.concat(rules.start);
        }
        return _this;
    }
    return CustomHighlightRules;
}(ace.require('ace/mode/elixir_highlight_rules').ElixirHighlightRules));
export { CustomHighlightRules };
var CustomElixirMode = /** @class */ (function (_super) {
    __extends(CustomElixirMode, _super);
    function CustomElixirMode(rules) {
        var _this = _super.call(this) || this;
        _this.HighlightRules = CustomHighlightRules.bind(null, rules);
        return _this;
    }
    return CustomElixirMode;
}(ace.require('ace/mode/elixir')
    .Mode));
export default CustomElixirMode;
