var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
import styled, { css } from 'styled-components';
import React from 'react';
import defaultCreatedTheme from "../../../theme";
import { backgroundGradientOption } from "../../../utils";
import { Icon } from '../Icon';
export var PanelWrapper = styled.div.withConfig({ displayName: "PanelWrapper", componentId: "sc-f4xzcn" })(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n  display: flex;\n  flex-direction: column;\n  width: 100%;\n  height: 100%;\n  overflow: hidden;\n  ", "\n"], ["\n  display: flex;\n  flex-direction: column;\n  width: 100%;\n  height: 100%;\n  overflow: hidden;\n  ",
    "\n"])), function (_a) {
    var theme = _a.theme;
    return css(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n    border: 1px solid ", ";\n    background-color: ", ";\n    border-radius: ", ";\n  "], ["\n    border: 1px solid ", ";\n    background-color: ", ";\n    border-radius: ", ";\n  "])), theme.greyscale.dark, theme.colors.white.default, theme.sizes.borderRadius);
});
export var PanelBody = styled.div.withConfig({ displayName: "PanelBody", componentId: "sc-1j5y3rp" })(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n  flex-grow: 1;\n  display: flex;\n  flex-direction: column;\n  overflow-y: auto;\n"], ["\n  flex-grow: 1;\n  display: flex;\n  flex-direction: column;\n  overflow-y: auto;\n"])));
export var PanelFooter = styled.div.withConfig({ displayName: "PanelFooter", componentId: "sc-12t6j4w" })(templateObject_4 || (templateObject_4 = __makeTemplateObject(["\n  min-height: 72px;\n  border-top: 1px solid ", ";\n  display: flex;\n  align-items: center;\n"], ["\n  min-height: 72px;\n  border-top: 1px solid ", ";\n  display: flex;\n  align-items: center;\n"])), function (_a) {
    var theme = _a.theme;
    return theme.greyscale.dark;
});
export var PanelHeaderWrapper = styled.div.withConfig({ displayName: "PanelHeaderWrapper", componentId: "sc-1pi302v" })(templateObject_6 || (templateObject_6 = __makeTemplateObject(["\n  height: 36px;\n  padding-left: 8px;\n  display: flex;\n  align-items: center;\n  justify-content: space-between;\n  flex-shrink: 0;\n  ", "\n"], ["\n  height: 36px;\n  padding-left: 8px;\n  display: flex;\n  align-items: center;\n  justify-content: space-between;\n  flex-shrink: 0;\n  ",
    "\n"])), function (_a) {
    var theme = _a.theme;
    return css(templateObject_5 || (templateObject_5 = __makeTemplateObject(["\n    background: ", ";\n    color: ", ";\n  "], ["\n    background: ", ";\n    color: ", ";\n  "])), backgroundGradientOption(theme, 'primary'), theme.colors.white.default);
});
export var PanelHeaderTitle = styled.div.withConfig({ displayName: "PanelHeaderTitle", componentId: "sc-1rn2240" })(templateObject_7 || (templateObject_7 = __makeTemplateObject(["\n  display: flex;\n  align-items: center;\n  align-self: stretch;\n  flex-grow: 1;\n  flex-shrink: 0;\n  font-weight: 600;\n  & > :first-child {\n    margin: 0 8px;\n  }\n"], ["\n  display: flex;\n  align-items: center;\n  align-self: stretch;\n  flex-grow: 1;\n  flex-shrink: 0;\n  font-weight: 600;\n  & > :first-child {\n    margin: 0 8px;\n  }\n"])));
export var PanelHeaderButtonWrapper = styled.div.withConfig({ displayName: "PanelHeaderButtonWrapper", componentId: "sc-1fia069" })(templateObject_8 || (templateObject_8 = __makeTemplateObject(["\n  display: flex;\n  align-self: stretch;\n  flex-shrink: 0;\n"], ["\n  display: flex;\n  align-self: stretch;\n  flex-shrink: 0;\n"])));
export var PanelHeaderButton = styled.button.withConfig({ displayName: "PanelHeaderButton", componentId: "sc-seiuqz" })(templateObject_10 || (templateObject_10 = __makeTemplateObject(["\n  flex: 1 0 auto;\n  padding: 0 5px;\n  border: none;\n  cursor: pointer;\n  font-weight: 600;\n  ", "\n"], ["\n  flex: 1 0 auto;\n  padding: 0 5px;\n  border: none;\n  cursor: pointer;\n  font-weight: 600;\n  ",
    "\n"])), function (_a) {
    var highlightedHover = _a.highlightedHover, separated = _a.separated, selected = _a.selected, theme = _a.theme;
    return css(templateObject_9 || (templateObject_9 = __makeTemplateObject(["\n    border-bottom: 1px solid ", " !important;\n    ", "\n\n    background-color: ", ";\n    color: ", ";\n\n    & svg {\n      fill: ", ";\n    }\n    \n    ", "\n\n    &:last-child {\n      border-top-right-radius: ", ";\n    }\n  "], ["\n    border-bottom: 1px solid ", " !important;\n    ",
        "\n\n    background-color: ", ";\n    color: ", ";\n\n    & svg {\n      fill: ", ";\n    }\n    \n    ",
        "\n\n    &:last-child {\n      border-top-right-radius: ", ";\n    }\n  "])), theme.colors.primary.default, separated && "border-left: 1px solid " + (selected ? theme.colors.primary.default : theme.colors.white.default) + ";", selected ? theme.colors.white.default : 'transparent', selected ? theme.colors.primary.default : theme.colors.white.default, selected ? theme.colors.primary.default : theme.colors.white.default, highlightedHover &&
        "&:hover {\n        background-color: " + theme.colors.primary.highlightedHover + ";\n        color: " + theme.colors.white.default + ";\n\n        & a {\n          color: " + theme.colors.white.default + ";\n        }\n\n        & svg {\n          fill: " + theme.colors.white.default + ";\n        }\n      }", theme.sizes.borderRadius);
});
PanelHeaderButton.defaultProps = {
    theme: defaultCreatedTheme,
    separated: true,
    highlightedHover: true,
    selected: false,
};
PanelHeaderWrapper.defaultProps = {
    theme: defaultCreatedTheme,
};
PanelWrapper.defaultProps = {
    theme: defaultCreatedTheme,
};
PanelFooter.defaultProps = {
    theme: defaultCreatedTheme,
};
export var PanelHeader = function (_a) {
    var headerActions = _a.headerActions, children = _a.children;
    var headerActionsComponent = headerActions === null || headerActions === void 0 ? void 0 : headerActions.map(function (_a, index) {
        var action = _a.action, highlightedHover = _a.highlightedHover, title = _a.title, icon = _a.icon, separated = _a.separated, className = _a.className, selected = _a.selected;
        var renderedIcon;
        if (icon) {
            if (typeof icon === 'string') {
                renderedIcon = React.createElement(Icon, { inheritColor: true, name: icon });
            }
            else {
                renderedIcon = icon;
            }
        }
        return (React.createElement(PanelHeaderButton, { highlightedHover: highlightedHover, key: index + "-" + title, onClick: action, separated: separated, className: className, selected: selected },
            title,
            " ",
            React.createElement("span", null, renderedIcon)));
    });
    return (React.createElement(PanelHeaderWrapper, null,
        React.createElement(PanelHeaderTitle, null, children),
        React.createElement(PanelHeaderButtonWrapper, null, headerActionsComponent)));
};
var templateObject_1, templateObject_2, templateObject_3, templateObject_4, templateObject_5, templateObject_6, templateObject_7, templateObject_8, templateObject_9, templateObject_10;
