import { getParticipantIds, getReviewerIds, isOwner, isParticipantInReview, isReviewer, } from '../utils';
import { CONTINUE_TEACHING, CONTINUE_CONVERSION, VIEW, REVIEW, START_CONVERSION, START_REVIEW, START_TEACHING, } from './constants';
export var useSessionButtonText = function (session, sme, currentUserId) {
    if (sme === void 0) { sme = false; }
    var archived = session.archived, teachingOwnerId = session.teachingOwnerId, conversionOwnerId = session.conversionOwnerId, handedOver = session.handedOver;
    var reviewerIds = getReviewerIds(sme, session);
    var participantIds = getParticipantIds(sme, session);
    var owner = isOwner(sme, currentUserId, {
        teachingOwnerId: teachingOwnerId,
        conversionOwnerId: conversionOwnerId,
    });
    var reviewer = isReviewer(currentUserId, reviewerIds);
    var participant = isParticipantInReview(currentUserId, participantIds);
    if (archived || (sme && handedOver)) {
        return VIEW;
    }
    if (owner) {
        return sme ? CONTINUE_TEACHING : CONTINUE_CONVERSION;
    }
    if (reviewer) {
        return participant ? REVIEW : START_REVIEW;
    }
    if (!teachingOwnerId && !conversionOwnerId) {
        return START_TEACHING;
    }
    if (!sme && !conversionOwnerId) {
        return START_CONVERSION;
    }
    return VIEW;
};
